#ifndef __LIGHT_UTL_HPP__
#define __LIGHT_UTL_HPP__

extern "C"{
#include <sys/time.h>
}

/** Return Difference of two time valuable  
 * @doc Computing Time difference of timeval t1-t2
 * @ret Time difference in second (double)
 */

inline double Tval_diff(const struct timeval& t1, const struct timeval& t2){
  double usdif = t1.tv_usec* 1.e-6 - t2.tv_usec* 1.e-6;
  return (double)t1.tv_sec - (double)t2.tv_sec + usdif;
}

template <class T>
inline const T Min( const T& a, const T&b)
{ return (a > b ? b : a);}

template <class T>
inline const T Abs( const T& a)
{ return (a > 0 ? a : -a);}

#endif
